SystemOrganization addCategory: #Deli!
SystemOrganization addCategory: #'Deli-models'!
SystemOrganization addCategory: #'Deli-configuration'!
SystemOrganization addCategory: #'Deli-models-tests'!
SystemOrganization addCategory: #'Deli-frontend'!
SystemOrganization addCategory: #'Deli-announcements'!
SystemOrganization addCategory: #'Deli-tutorial'!
SystemOrganization addCategory: #'Deli-util'!

WAApplication subclass: #DLApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLApplication class methodsFor: 'as yet unclassified' stamp: 'test 6/14/2009 15:22'!
description
	^ 'DLApplication'! !

!DLApplication methodsFor: 'as yet unclassified' stamp: 'test 6/14/2009 15:25'!
initialize
	super initialize.
	self addLibrary: DLFileLibrary.
	self preferenceAt: #mainClass    	 put: DLAuthMain.
	self preferenceAt: #sessionClass 	 put: DLSession.
	self preferenceAt: #useSessionCookie put: true.
	self preferenceAt: #rootComponent    put: DLRootComponent.! !

HPISession subclass: #DLSession
	instanceVariableNames: 'user announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:04'!
announcer
	^ announcer ifNil: [ announcer := Announcer new. ].! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:03'!
charSet
	^ 'iso-8859-1'! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/10/2009 00:11'!
login: aUsername
	super login: aUsername.
	self user: (DLUser getOrCreateFrom: {#userName -> self username}).! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/10/2009 18:10'!
logout
	self expire.
	self user: nil.
	super logout.! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/10/2009 00:11'!
user
	^ user! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user: anObject

	user := anObject.! !

MAComponentRenderer subclass: #DLCssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderContainer: aDescription 
	html definitionList
		class: (self classFor: aDescription);
		with: [ super renderContainer: aDescription ]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderControl: aDescription
	html definitionData
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription.
				  html div class:'helptext'; with: aDescription comment.
			 ]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html definitionTerm
		class: 'group';
		with: group! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderLabel: aDescription
	html definitionTerm
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

MAExternalFileModel subclass: #DLMAExternalFileModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:33'!
calcFilesize
	filesize := self contents size.! !

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:35'!
filesize: aFilesize
	"Allow to manually set filesize so we can save it somewhere else."
	filesize := aFilesize.! !

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:30'!
isEmpty
	^ location isEmpty! !

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:30'!
location: aLocation

	location := aLocation.! !

Announcement subclass: #DLLogoutAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

Announcement subclass: #DLViewCompReplacement
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

!DLViewCompReplacement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:57'!
forComponent: aComponent
	^ self new
		component: aComponent;
		yourself.! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component

	^ component! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component: anObject

	component := anObject.! !

HPIAuthMain subclass: #DLAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLAuthMain methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 23:33'!
createRoot
	^ super createRoot
		addDecoration: DLAuthentication new;
		yourself! !

WAFileLibrary subclass: #DLFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLFileLibrary methodsFor: 'as yet unclassified' stamp: 'cr 6/1/2009 01:16'!
selectorsToInclude

	^ Array with: 'styleCss'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'sebh 6/11/2009 12:08'!
styleCss
	^
'
html {
	margin: 0 0 0 0;
	padding: 0 0 0 0;
	font-family: sans-serif;
}


.header {
	width: 100%;
	height: 40px;
	background-color: #eee;
}

.header h1 {
	float: right;
}

.footer {
	width:100%;
	height:20px;
	position:fixed;
	bottom:0px;
}

.menu {
	width: 250px;
	height: 100%;
	float:left;
}

.menu h2 {
	font-size: 16px;
}

.content {
	float: left;
	left: 260px;
	min-width:500px;
	margin-top: 25px;
	margin-bottom: 50px;
}

.content th {
	text-align: left;
	font-weight: normal
}

.content th.required {
	text-align: left;
	font-weight: bold;
}


.helptext {
	font-size: 10px;
	color: #777;
}

thead>td {
	font-weight: bold;
}
'! !

!DLFileLibrary methodsFor: 'as yet unclassified' stamp: 'cr 6/1/2009 01:14'!
updateRoot:	anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: DLFileLibrary / #styleCss.! !

MAFileUploadComponent subclass: #DLMAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:35'!
isMultipart
	^ true! !

!DLMAFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:36'!
renderEditorOn: html
	self value isNil
		ifTrue:  [ self renderUploadOn: html ]
		ifFalse: [ self renderReplaceOn: html ]! !

!DLMAFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:36'!
renderReplaceOn: html
	html anchor
		url: (self value urlOn: html);
		with: self value filename.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.
	
	html fileUpload
		id: self labelId;
		on: #replace of: self.
	html submitButton
		text: 'replace'.! !

!DLMAFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:36'!
replace: aFile
	aFile notNil ifTrue:[ 
		self value finalize.
		self value: nil.
		self upload: aFile.
	].
	! !

WATask subclass: #DLTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLTask subclass: #DLDeleteTask
	instanceVariableNames: 'deleteElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLDeleteTask subclass: #DLAdminDeleteTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeleteTask methodsFor: 'as yet unclassified' stamp: 'caro 6/14/2009 16:14'!
permissionCheck

	^ self session user isAdmin! !

!DLDeleteTask class methodsFor: 'as yet unclassified' stamp: 'caro 6/14/2009 16:43'!
for: anDeleteElement
	^ self new
		deleteElement: anDeleteElement;
		yourself.! !

!DLDeleteTask methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:17'!
action
	| answer |
	answer := self call: (DLAdminConfirmDeleteComp for: self deleteElement ).
	answer ifTrue: [ self deleteElement destroy ].
	self answer: true.! !

!DLDeleteTask methodsFor: 'accessing' stamp: 'caro 6/14/2009 16:45'!
deleteElement

	^ deleteElement! !

!DLDeleteTask methodsFor: 'accessing' stamp: 'caro 6/14/2009 16:45'!
deleteElement: anObject

	deleteElement := anObject.! !

!DLDeleteTask methodsFor: 'accessing' stamp: 'caro 6/14/2009 16:17'!
permissionCheck
	^ self session isLoggedIn.! !

DLDeleteTask subclass: #DLUserDeleteTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 11:40'!
action
	"I have the same semantics like the usual go method but am called only after a permission check"
	^ self subclassResponsibility! !

!DLTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 11:40'!
go
	self permissionCheck
	ifTrue: [self action]
	ifFalse:[self call: DLPermissionDeniedComp new.].! !

!DLTask methodsFor: 'as yet unclassified' stamp: 'Marik 6/4/2009 20:58'!
permissionCheck

	^ false! !

DLTask subclass: #DLUpdateTask
	instanceVariableNames: 'updateElement callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUpdateTask subclass: #DLAdminUpdateTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminUpdateTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:53'!
descriptionCreate
	^self updateElement descriptionAdminCreate
! !

!DLAdminUpdateTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:52'!
descriptionUpdate
	^self updateElement descriptionAdminUpdate
! !

!DLAdminUpdateTask methodsFor: 'as yet unclassified' stamp: 'Marik 6/4/2009 20:58'!
permissionCheck

	^ self session user isAdmin! !

!DLUpdateTask class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 22:43'!
for: anUpdateElement
	^ self new
		updateElement: anUpdateElement;
		yourself.! !

!DLUpdateTask class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 22:43'!
for: anUpdateElement withCallback: aCallback
	^ self new
		updateElement: anUpdateElement;
		callback: aCallback;
		yourself.! !

!DLUpdateTask class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUpdateElement
	^ SqsColumn new associatedClass: #DLFileType;
		 manuallyMaintained: false;
		 columnName: 'update_element_id';
		 sqlType: #integer;
		 objectClass: #DLFileType;
		 tableName: 'wa_presenters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'updateElement';
		 yourself! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:54'!
action
	self updateElement: (self call: ((self description asComponentOn: self updateElement) addValidatedForm)).
	self updateElement ifNotNil: [
		self updateElement save].
	self callback
		ifNil: [self answer: true]
		ifNotNil: [self call: self callback].! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:42'!
callback
	^ callback! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:42'!
callback: anObject 
	callback := anObject! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:51'!
description
	self updateElement oid isNil
	ifTrue: 	[^ self descriptionCreate]
	ifFalse: [^ self descriptionUpdate].! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:52'!
descriptionCreate
	^self updateElement descriptionCreate
! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:52'!
descriptionUpdate
	^self updateElement descriptionUpdate
! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:44'!
initialize
	super initialize.
	self callback: nil.! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:50'!
permissionCheck
	^ self session isLoggedIn.! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'Marik 6/4/2009 20:51'!
updateElement

	^ updateElement! !

!DLUpdateTask methodsFor: 'accessing' stamp: 'Marik 6/4/2009 20:51'!
updateElement: anObject

	updateElement := anObject.! !

DLUpdateTask subclass: #DLUserUpdateTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserUpdateTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:53'!
descriptionCreate
	^self updateElement descriptionUserCreate
! !

!DLUserUpdateTask methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:53'!
descriptionUpdate
	^self updateElement descriptionUserUpdate
! !

MACommandColumn subclass: #DLMAConditionalCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAConditionalCommandColumn methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:53'!
addCommand: aCommand condition: aCondition text: aText
	self commands add: aCondition -> (aCommand -> aText).! !

!DLMAConditionalCommandColumn methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:59'!
addCondition: aCondition text: aText
	self commands add: aCondition -> (nil -> aText).! !

!DLMAConditionalCommandColumn methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 00:07'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each |
			| condition block text |
			condition := each key. block := each value key. text := each value value.
			(condition value: anObject)
			ifTrue:[
				(block isNil)
				ifTrue:  [ html text: text. ]
				ifFalse: [ html anchor
								callback: [ block value: anObject ];
								with: text]
			]]
		separatedBy: [ html space ]! !

HPIAuthentication subclass: #DLAuthentication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLAuthentication methodsFor: 'as yet unclassified' stamp: 'sebh 6/10/2009 13:12'!
verifyPassword: password forUser: username
	^ self session isLoggedIn or: [
			(username = 'jack') | (username = 'john')
			ifTrue: [self session login: username]
			ifFalse:[super verifyPassword: password forUser: username].
			self session isLoggedIn]! !

WAComponent subclass: #DLComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLComponent subclass: #DLAdminConfirmDeleteComp
	instanceVariableNames: 'deleteElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminConfirmDeleteComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/15/2009 11:04'!
for: anElement
	^ self new
		deleteElement: anElement;
		yourself.! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement

	^ deleteElement! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement: anObject

	deleteElement := anObject.! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:14'!
permissionCheck
	^ self session user isAdmin! !

!DLAdminConfirmDeleteComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/15/2009 11:16'!
renderContent: html
	html text: 'Mchten sie "', self deleteElement asString, '" wirklich lschen?'; break.
	html anchor 
				callback: [self answer: true];
				text: 'Ja'.
	html break.
	html anchor
				callback: [self answer: false];
				text: 'Nein'.! !

!DLComponent methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:29'!
permissionCheck

	^ false.! !

!DLComponent methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:29'!
renderContent: html

	self subclassResponsibility! !

!DLComponent methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:58'!
renderContentOn: html
	self permissionCheck 
		ifTrue: [self renderContent: html.]
		ifFalse:[html div with: 'Permission denied']
	! !

DLComponent subclass: #DLDetailComp
	instanceVariableNames: 'detailElement additionalComps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLDetailComp subclass: #DLAdminDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDetailComp methodsFor: 'as yet unclassified' stamp: 'Marik 6/4/2009 21:21'!
permissionCheck

	^ self session user isAdmin! !

!DLAdminDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 20:16'!
updateComponent
	^ DLAdminUpdateTask! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:28'!
for: anDetailElement

	^self new
		detailElement: anDetailElement;
		yourself.! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 17:16'!
for: anDetailElement additionalComp: aComponent
	^self for: anDetailElement additionalComps: {aComponent}! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 17:15'!
for: anDetailElement additionalComps: aComponentList

	|new|
	new := self new
		detailElement: anDetailElement.
	new additionalComps addAll: aComponentList.
	^ new.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps
	^ additionalComps! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps: anObject 
	additionalComps := anObject! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:44'!
children
	^ self additionalComps asArray.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement

	^ detailElement! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement: anObject

	detailElement := anObject.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:44'!
initialize

	super initialize.
	self additionalComps: OrderedCollection new.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:14'!
permissionCheck
	
	^ self session isLoggedIn! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 20:21'!
renderActions: html
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [self call: (self updateComponent for: self detailElement)];
				text: 'Bearbeiten'.
			].
		].! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 20:05'!
renderContent: html
	self renderActions: html.
	html definitionList with: [
		self detailElement descriptionDetail do: [:desc |
			html definitionTerm: desc label.
			html definitionData: (desc accessor read: (self detailElement)).
		]
	].
	self additionalComps do: [:each | 
		html div with: each.
	].! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 20:16'!
updateComponent
	^ DLUpdateTask! !

DLDetailComp subclass: #DLUserDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserDetailComp subclass: #DLUserDeliveryDetailComp
	instanceVariableNames: 'deadline group lecture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeliveryDetailComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/16/2009 22:57'!
for: aDeadline user: aUser
	| group deliverables delivery |
	group := (SqsSearch for: DLGroup) detect: [:aGroup |
			"(aGroup lecture = aDeadline lecture) &" (aGroup students includes: aUser)] ifNone: [nil].
	delivery := DLDelivery getOrCreateFrom: {#group -> group. #deadline -> aDeadline.}.
	deliverables := OrderedCollection new.
	(aDeadline requirements) do: [ :aRequirement |
		deliverables add: (DLUpdateTask for: (DLDeliverable getOrCreateFrom: {	
			#delivery -> delivery. #deliverableRequirement -> aRequirement
		})).
	].
	
	^self for: delivery additionalComps: deliverables.! !

!DLUserDeliveryDetailComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 18:03'!
deadline

	^ deadline! !

!DLUserDeliveryDetailComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 18:03'!
deadline: anObject

	deadline := anObject.! !

!DLUserDeliveryDetailComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 18:03'!
group

	^ group! !

!DLUserDeliveryDetailComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 18:03'!
group: anObject

	group := anObject.! !

!DLUserDeliveryDetailComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 18:03'!
lecture

	^ lecture! !

!DLUserDeliveryDetailComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 18:03'!
lecture: anObject

	lecture := anObject.! !

!DLUserDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:17'!
renderActions: html
	! !

!DLUserDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 20:16'!
updateComponent
	^ DLUserUpdateTask! !

DLUserDetailComp subclass: #DLUserLectureDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserLectureDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/18/2009 14:53'!
renderActions: html
	html div class: 'actions'; with: [
		html anchor
			callback: [self call: (self updateComponent for: (DLGroup newFrom: {#lecture->self detailElement}))];
			text: 'Gruppe anlegen'.
		].! !

DLUserDetailComp subclass: #DLUserProfileDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserProfileDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 20:21'!
renderActions: html
	"Duplicate from DLDetailComp"
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [self call: (self updateComponent for: self detailElement)];
				text: 'Bearbeiten'.
			].
		].! !

DLComponent subclass: #DLListComp
	instanceVariableNames: 'listClass magritteReport collectionFields valueFields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLListComp subclass: #DLAdminListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminListComp subclass: #DLAdminDeadLineListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeadLineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 10:58'!
columnDetail
^ (MACommandColumn new
			addCommand: [:listElement |
					self call: (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLAdminDeliveryListComp with: {#deadline->listElement}).}
					)
			]
			text: 'Details';
			yourself).! !

!DLAdminDeadLineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:29'!
listClass
	^ DLDeadline! !

DLAdminListComp subclass: #DLAdminDeliveryListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeliveryListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:36'!
listClass
	^ DLDelivery! !

!DLAdminDeliveryListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 10:58'!
listObjects
	"Precreate all Deliveries for a given lecture"
	| deadline |
	deadline := self valueFieldsAt: #deadline.
	deadline ifNotNil: [ 
		| groups |
		groups := (SqsSearch for: DLGroup) select: [:aGroup | (aGroup lecture) = (deadline lecture)].
		groups do: [:aGroup | 
			DLDelivery getOrCreateFrom: {#deadline->deadline. #group->aGroup}.	
		]
	].
	^ super listObjects.
	! !

DLAdminListComp subclass: #DLAdminLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:27'!
columnDetail
	^ (MACommandColumn new
			addCommand: [:listElement |
					self call: (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLAdminListComp for: DLDeadline with: {#lecture->listElement}). 
													(DLAdminListComp for: DLGroup 	with: {#lecture->listElement})}
					)
			]
			text: 'Details';
			yourself).! !

!DLAdminLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 17:34'!
listClass
	^ DLLecture.! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:25'!
deleteComponent
	^DLAdminDeleteTask! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:25'!
detailComponent
	^DLAdminDetailComp! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:39'!
listDescription
	^ (self listClass) new descriptionAdminList! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 17:01'!
permissionCheck
	^ self session user isAdmin! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:25'!
updateComponent
	^DLAdminUpdateTask! !

!DLListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:26'!
for: aListElement
	^ self new
		listClass: aListElement;
		yourself.! !

!DLListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:49'!
for: aClass with: anObjectDict
	"Given a dictionary of #fieldname to object, this method constructs a query."
	| newlist inspect |
	newlist := self new.
	newlist listClass: aClass.
	inspect := aClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:50'!
with: anObjectDict
	| newlist inspect |
	newlist := self new.
	inspect := newlist listClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/18/2009 14:50'!
actions
	^ {
		(self listClass rightCreate: self session user) ->	
			((self listClass metaName ,' anlegen')->[self call: (self updateComponent for: (self listClass newFrom: self valueFields))])
	}! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/18/2009 14:42'!
additionalActions
	^ {}! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 14:47'!
additionalColumns
	^ {}! !

!DLListComp methodsFor: 'report' stamp: 'sebh 6/18/2009 16:25'!
call: someComponent
	"Refresh list after a call to another component, values might have changed."
	| result |
	result := super call: someComponent.
	self refreshReport.
	^ result! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:26'!
children

	^ Array with: self magritteReport.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields

	^ collectionFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields: anObject

	collectionFields := anObject.! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 19:24'!
columnDelete
	^ (MACommandColumn new 
			addCommand: [:listElement | self call: (self deleteComponent for: listElement)]  
			text:'Lschen'; 
			yourself).	! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 19:23'!
columnDetail
	^ (MACommandColumn new
			addCommand: [:listElement | self call: (self detailComponent for: listElement)]
			text: 'Details';
			yourself)! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 19:24'!
columnUpdate
	^ (MACommandColumn new 
			addCommand: [:listElement | self call: (self updateComponent for: listElement)]  
			text:'Bearbeiten'; 
			yourself)! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 20:59'!
columns
	| cols |
	cols := OrderedCollection new.
	(self listClass rightDetail: self session user) ifTrue: [ cols add: self columnDetail. ].
	(self listClass rightUpdate: self session user) ifTrue: [ cols add: self columnUpdate. ].
	(self listClass rightDelete: self session user) ifTrue: [ cols add: self columnDelete. ].
	cols addAll: self additionalColumns.
	^ cols select: [:aColumn | aColumn ~= nil ] ! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 19:22'!
deleteComponent
	^DLDeleteTask! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 19:21'!
detailComponent
	^DLDetailComp! !

!DLListComp methodsFor: 'initialize-release' stamp: 'sebh 6/13/2009 21:18'!
initialize
	super initialize.
	self valueFields: OrderedCollection new.
	self collectionFields: OrderedCollection new.! !

!DLListComp methodsFor: 'report' stamp: 'sebh 6/15/2009 22:28'!
initializeReport
	self magritteReport: (MAReport rows: self listObjects
							 	  description: self listDescription).
	self columns do: [:each | self magritteReport addColumn: each].! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass

	^ listClass! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass: anObject

	listClass := anObject.! !

!DLListComp methodsFor: 'report' stamp: 'cr 6/6/2009 17:26'!
listDescription

	^ (self listClass) new descriptionList! !

!DLListComp methodsFor: 'report' stamp: 'sebh 6/13/2009 21:20'!
listObjects
	^ ((SqsSearch for: self listClass) select: self listSelectBlock) select: [:anObject |
		"Get all objects that have been selected by for:with: - TODO: Move this to query"
		| truth |
		truth := true.
	   self collectionFields do: 
			[:field | ((anObject perform: field key) perform: #includes: with: field value) ifFalse: [truth := false] ].
		self valueFields do:
			[:field | ((anObject perform: field key) = field value) ifFalse: [truth := false]].
		truth
	]! !

!DLListComp methodsFor: 'report' stamp: 'sebh 6/13/2009 18:40'!
listSelectBlock
	^[:anObject | ]
	! !

!DLListComp methodsFor: 'report' stamp: 'MG 6/5/2009 15:31'!
magritteReport
	"Lazily initialize report"
	
	magritteReport ifNil: [self initializeReport].
	^ magritteReport! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:23'!
magritteReport: anObject

	magritteReport := anObject.! !

!DLListComp methodsFor: 'rights' stamp: 'sebh 6/6/2009 17:00'!
permissionCheck
	^ self session isLoggedIn.! !

!DLListComp methodsFor: 'report' stamp: 'sebh 6/18/2009 16:25'!
refreshReport
	self magritteReport rows: self listObjects.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/18/2009 14:46'!
renderActions: html
	html div class: 'actions'; with: [
		
		self actions do: [:each |
			| permission text callback |
			permission := each key. text := each value key. callback := each value value.
			permission ifTrue: [		
				html anchor
					callback: callback;
					text: text
				]
			] separatedBy: [html space.]
		].! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/18/2009 16:25'!
renderContent: html
	self refreshReport.
	self renderActions: html.
	html div with: self magritteReport.! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 20:15'!
updateComponent
	^ DLUpdateTask! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields

	^ valueFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields: anObject

	valueFields := anObject.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:57'!
valueFieldsAt: aKey
	| temp |
	temp := valueFields select: [:each | each key = aKey ].
	^ temp first value.! !

DLListComp subclass: #DLUserListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserListComp subclass: #DLUserDeadlineListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeadlineListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:24'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp class methodsFor: 'as yet unclassified' stamp: 'Marik 6/9/2009 13:59'!
for: aListElement user: aUser
	^ self new
		listClass: aListElement;
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'sebh 6/17/2009 13:40'!
additionalColumns
	^ { 
		(MACommandColumn new
			addCommand: 
					[ :listElement | 
					self call: (DLUserUpdateTask 
							for: (DLDelivery getOrCreateFrom: {#deadline->listElement. #group->(self session user groupForLecture: (listElement lecture))})
						) ]
				text: 'Neue Abgabe';
			yourself)
	 }.! !

!DLUserDeadlineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:22'!
listClass
	^ DLDeadline! !

!DLUserDeadlineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 14:23'!
listObjects
	
	| result|
	result := OrderedCollection new.
	"deadlines := (SqsSearch for: self listClass) findAll.
	lectureMemberships := (SqsSearch for: DLLecture) select: [:aLecture | aLecture students includes: self user].
	deadlines do:[:aDeadline | lectureMemberships do:[:aLecture | (aDeadline lecture oid = aLecture oid) ifTrue: [result add: aDeadline]]]."
	
	result := (SqsSearch for: DLDeadline) findAll 
		select: [:aDeadline | 
			| group truth |
			truth := false.
			group := self session user groupForLecture: aDeadline lecture.
			group notNil ifTrue: [aDeadline lecture = group lecture ifTrue:[truth := true]].
			truth.].
	^result! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user

	^ user! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserGroupListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserGroupListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 15:31'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 18:12'!
listClass
	^ DLGroup! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:29'!
listSelectBlock
	^ [:aGroup | aGroup students includes: self user]! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user

	^ user! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 00:04'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			addCommand: [:listElement | listElement addStudent: self session user]
			condition:  [:listElement | (listElement students includes: self session user) ~= true]
			text: 'Beitreten';
			addCondition:  [:listElement | (listElement students includes: self session user)]
			text: 'Bereits beigetreten';
			yourself).}! !

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/18/2009 14:54'!
detailComponent
	^ DLUserLectureDetailComp! !

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:36'!
initializeReport
	super initializeReport.
	self magritteReport tableEmpty:  'Noch keiner ', self listClass metaName, ' beigetreten.'! !

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 18:11'!
listClass
	^ DLLecture! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:12'!
columnDelete
	^ nil! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:15'!
columnUpdate
	^ nil! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:26'!
detailComponent
	^DLUserDetailComp! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:39'!
listDescription
	^ (self listClass) new descriptionUserList! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:02'!
renderActions: html
	! !

DLComponent subclass: #DLPermissionDeniedComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLPermissionDeniedComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:02'!
permissionCheck
	"Always allow anyone to see permission denied"
	^ true! !

!DLPermissionDeniedComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:24'!
renderContent: html
	html heading: 'Permission denied';
		  paragraph: 'You have insufficient rights to open this page.'! !

WAComponent subclass: #DLMenuComp
	instanceVariableNames: 'entries content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 18:03'!
addEntries
	"If an inheriting method has defined this method, we use it to automagically insert entries"
	self entries
					
		add: 'Andere Aktionen' -> { 
			'Ausloggen' -> [self session logout.]}.! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/26/2009 17:12'!
addEntry: aString withAction: aBlock
	
	^ self entries add: aString -> aBlock! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:00'!
entries

	^ entries ifNil: [self entries: OrderedCollection new. self addEntries. ^ entries]! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 5/26/2009 17:08'!
entries: anObject

	entries := anObject.! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 18:58'!
renderContentOn: html
	self entries
		do: [:entry | self renderEntry: entry on: html. ]
		separatedBy: [html break].! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 15:50'!
renderEntry: anEntry on: html
	self renderEntry: anEntry on: html level: 2 ! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/28/2009 12:45'!
renderEntry: anEntry on: html level: aLevel
	anEntry value isCollection
	ifTrue: [ 
		html heading: anEntry key level: aLevel.
		anEntry value do: [:entry | self renderEntry: entry on: html level: aLevel+1] separatedBy: [html break].
	]
	ifFalse: [
		html anchor
			callback: anEntry value;
			with: anEntry key.
	].! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 13:42'!
showComponent: aComponent
	self session announcer announce: ((self signal) forComponent: aComponent)! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:55'!
signal
	^ DLViewCompReplacement! !

DLMenuComp subclass: #DLUserMenuComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserMenuComp subclass: #DLAdminMenuComp
	instanceVariableNames: 'lectureListComp formComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:49'!
addEntries
	(self session user isAdmin) ifTrue:
	[self entries
		add: 'Admin' -> {
			'Deadlines' -> 			[self showComponent: (DLAdminDeadLineListComp new)].
			'Gruppen'   -> 			[self showComponent: (DLAdminListComp for: DLGroup)].
			'Lehrveranstaltungen'-> [self showComponent: (DLAdminLectureListComp new)].
			'Benutzer' 			   -> [self showComponent: (DLAdminListComp for: DLUser)].
			'Dateitypen' 		   -> [self showComponent: (DLAdminListComp for: DLFileType)].
		}].
		
	super addEntries.
		! !

!DLUserMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:38'!
addEntries
	self entries
	
		add: 'Benutzer' -> {
			'Aktuelle Lehrveranstaltungen' -> [self showComponent: (DLUserLectureListComp new)].
			'Meine Deadlines' -> [self showComponent: (DLUserDeadlineListComp for: self session user)].
			'Meine Gruppen'   -> [self showComponent: (DLUserListComp for: DLGroup with: {#students->self session user})].
			'Mein Profil'	   -> [self showComponent: (DLUserProfileDetailComp for: self session user)].
			'Meine Lehrveranstaltungen'-> [self showComponent: (DLUserLectureListComp with: {#students->self session user})].
		}.
	super addEntries! !

WAComponent subclass: #DLMenuEntry
	instanceVariableNames: 'content active block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
active

	^ active! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
active: anObject

	active := anObject.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block

	^ block! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block: anObject

	block := anObject.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
content

	^ content! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
content: anObject

	content := anObject.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
initialize
	super initialize.
	self active: False.! !

WAComponent subclass: #DLRootComponent
	instanceVariableNames: 'menuComp viewComp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLRootComponent class methodsFor: 'as yet unclassified' stamp: 'sebh 6/10/2009 12:17'!
canBeRoot
	^ true.! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 12:00'!
children
	^ Array with: self viewComp with: self menuComp! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 18:56'!
initialize
	super initialize.
	self menuComp: DLAdminMenuComp new.
	self session announcer on: DLViewCompReplacement do: [:announcement | self viewComp: announcement component ].
	self session announcer on: DLLogoutAnnouncement  do: [:announcement | self answer: true. ]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/13/2009 18:55'!
menuComp

	^ menuComp! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
menuComp: anObject

	menuComp := anObject.! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 14:17'!
renderContentOn: html
	html div class:'header';  with: [html heading: 'Deli'].
	html div class:'menu';	  with: self menuComp.
	html div class:'content'; with: self viewComp.
	html div class:'footer';  with: [html text: 'Deli. A product.']! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp

	^ viewComp! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp: anObject

	viewComp := anObject.! !

Object subclass: #DLModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

DLModel subclass: #DLDeadline
	instanceVariableNames: 'deadlineName deadlineDescription lecture date time requirements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 12:30'!
descriptionDate
	^ (MADateDescription auto: 'date' label: 'Datum' priority: 40)
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:01'!
descriptionDeadlineDescription
	^ (MAMemoDescription auto:'deadlineDescription' label: 'Beschreibung' priority: 30) 
		beRequired;
		yourself.! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:01'!
descriptionDeadlineName
	^ (MAStringDescription auto: 'deadlineName' label: 'Titel' priority: 20)
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 23:08'!
descriptionLecture
	^ (MASingleOptionDescription auto: 'lecture' label: 'Vorlesung' priority: 10)
			optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | ]);
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'Marik 6/9/2009 15:31'!
descriptionRequirements
	^ (MAToManyRelationDescription auto: 'requirements' label:'Abgaben' priority:60)
			classes: (Array with: DLRequirement);
			default: Array new;
			yourself.! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/4/2009 12:30'!
descriptionTime
	^ (MATimeDescription auto: 'time' label: 'Uhrzeit' priority: 50)
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:33'!
metaName
	^ 'Abgabetermin'! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'date';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'date';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineDescription';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineName';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirements
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_deadlines_requirements';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_deadline_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_deadlines';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_deadline_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'requirements_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_requirements';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'requirements_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLRequirement;
		 linkedVariable: 'requirements';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTime
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'time';
		 sqlType: #time;
		 objectClass: #Time;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'time';
		 yourself! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 6/9/2009 17:48'!
canonicalName
	^ self deadlineName! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:53'!
collectDependentObjects
	| dependentDeliveries dependentRequirement |
	dependentDeliveries := (SqsSearch for: DLDelivery)    select: [:aDelivery   | aDelivery    deadline = self].
	dependentRequirement:= self requirements.
	^ dependentDeliveries! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date

	^ date! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date: anObject

	date := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription

	^ deadlineDescription! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription: anObject

	deadlineDescription := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName

	^ deadlineName! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName: anObject

	deadlineName := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:22'!
descriptionList
 ^ super description select: [:each | #(deadlineDescription deadlineName date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 22:47'!
descriptionUpdate
	^ self descriptionList! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group

	^ group! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group: anObject

	group := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/8/2009 23:14'!
initialize
	super initialize.
	self requirements: OrderedCollection new.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture

	^ lecture! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture: anObject

	lecture := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:56'!
requirements

	^ requirements! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:56'!
requirements: anObject

	requirements := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time

	^ time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time: anObject

	time := anObject.! !

DLModel subclass: #DLDeliverable
	instanceVariableNames: 'delivery deliverableRequirement filePath fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:10'!
descriptionDeliverableRequirement
	^ (MAStringDescription auto: 'deliverableRequirement' label: 'Requirement' priority: 20)
			beReadonly;
			yourself.
! !

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'Marik 6/10/2009 14:06'!
descriptionDelivery
	^ (MAStringDescription auto: 'delivery' label: 'Delivery' priority: 10)
			beHidden;
			beRequired;
			yourself.
! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeliverableRequirement
	^ SqsColumn new associatedClass: #DLRequirement;
		 manuallyMaintained: false;
		 columnName: 'deliverable_requirement_id';
		 sqlType: #integer;
		 objectClass: #DLRequirement;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deliverableRequirement';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDelivery
	^ SqsColumn new associatedClass: #DLDelivery;
		 manuallyMaintained: false;
		 columnName: 'delivery_id';
		 sqlType: #integer;
		 objectClass: #DLDelivery;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'delivery';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFilePath
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'file_path';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filePath';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFileSize
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'file_size';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'fileSize';
		 yourself! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement

	^ deliverableRequirement! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement: anObject

	deliverableRequirement := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery

	^ delivery! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery: anObject

	delivery := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/17/2009 01:32'!
description
	| tempDescription |
	tempDescription := super description copy.
	tempDescription add: (
	 (MAFileDescription auto: 'fileModel' label: 'Datei' priority: 80)
		addCondition: [:anUploadedFile | self deliverableRequirement filetype extensions includes: '.', anUploadedFile extension ] 
		labelled: 'Dateityp muss einer der folgenden Endungen entsprechen: ', self deliverableRequirement filetype extensionsText;
		comment: 'Nur Dateien mit Endung(en) ', self deliverableRequirement filetype extensionsText, ' erlaubt.';
		beRequired;
		componentClass: DLMAFileUploadComponent;
		kind: DLMAExternalFileModel;
		yourself ).
	^ tempDescription.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/17/2009 12:18'!
descriptionList
 ^ super description select: [:each | #(deliverabelRequirement fileName) includes: each accessor selector]! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/17/2009 12:12'!
fileModel

	| separatedPath filename delimiter path |
	self filePath isEmpty ifTrue: [^ nil].
	delimiter := (FileDirectory default pathNameDelimiter).
	separatedPath := self filePath tokensBasedOn: delimiter.
	path := separatedPath allButLast.
	filename := separatedPath last.
	^ DLMAExternalFileModel new 
				location: path;
				filename: filename;
				filesize: self fileSize;
				yourself.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:37'!
fileModel: aFileModel
	| delimiter |
	delimiter := (FileDirectory default pathNameDelimiter) asString.
	self filePath: (aFileModel location join: delimiter),delimiter, aFileModel filename.
	self fileSize: aFileModel filesize.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:21'!
filePath

	^ filePath! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:24'!
filePath: anObject

	filePath := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:36'!
fileSize

	^ fileSize! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:37'!
fileSize: anObject

	fileSize := anObject.! !

!DLDeliverable methodsFor: 'accessing-generated' stamp: 'Marik 6/10/2009 17:22'!
initialize 

	super initialize.
	self filePath: ''.! !

DLModel subclass: #DLDelivery
	instanceVariableNames: 'group deadline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDelivery class methodsFor: 'as yet unclassified' stamp: 'Marik 6/9/2009 17:38'!
descriptionDeadline
	^ (MASingleOptionDescription auto: 'deadline' label: 'Deadline' priority: 10)
			optionsAndLabels: (DLDeadline getKeyValueSelect: [:aDeadline | ]);
			beRequired;
			yourself.! !

!DLDelivery class methodsFor: 'as yet unclassified' stamp: 'Marik 6/9/2009 17:43'!
descriptionGroup
	^ (MASingleOptionDescription auto: 'group' label: 'Gruppe' priority: 20)
			optionsAndLabels: (DLGroup getKeyValueSelect: [:aGroup | ]);
			beRequired;
			yourself.! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 6/18/2009 15:52'!
getOrCreateFrom: anArray
 	| result |
	result := super getOrCreateFrom: anArray.
	result deadline requirements do: [:aRequirement |
		DLDeliverable getOrCreateFrom: {#delivery->result. #deliverableRequirement->aRequirement}.
		].
	^ result.! !

!DLDelivery class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:31'!
metaName
	^ 'Abgabe'! !

!DLDelivery class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadline
	^ SqsColumn new associatedClass: #DLDeadline;
		 manuallyMaintained: false;
		 columnName: 'deadline_id';
		 sqlType: #integer;
		 objectClass: #DLDeadline;
		 tableName: 'dl_deliverys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadline';
		 yourself! !

!DLDelivery class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroup
	^ SqsColumn new associatedClass: #DLGroup;
		 manuallyMaintained: false;
		 columnName: 'group_id';
		 sqlType: #integer;
		 objectClass: #DLGroup;
		 tableName: 'dl_deliverys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'group';
		 yourself! !

!DLDelivery methodsFor: 'as yet unclassified' stamp: 'Marik 6/10/2009 13:45'!
canonicalName
	^ self ! !

!DLDelivery methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:48'!
collectDependentObjects
	| dependentDeliverables |
	dependentDeliverables := (SqsSearch for: DLDeliverable) select: [:aDeliverable | aDeliverable delivery = self].
	^ dependentDeliverables! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline

	^ deadline! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline: anObject

	deadline := anObject.! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group

	^ group! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group: anObject

	group := anObject.! !

DLModel subclass: #DLFileType
	instanceVariableNames: 'filetypeName extensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLFileType class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:45'!
createFileType: aTypeName extensions: someExtensions
	^ self new
		filetypeName: aTypeName;
		extensions: someExtensions;
		save;
		yourself.! !

!DLFileType class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:46'!
descriptionExtensions
	^ (MAMemoDescription auto: 'extensionsText' label: 'Dateiendungen' priority: 20)
			comment: 'Eine komma-separierte Liste der Dateiendungen z.B. ".pdf,.ppt"';
			yourself.
! !

!DLFileType class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:47'!
descriptionFiletypeName
	^ (MAStringDescription auto: 'filetypeName' label: 'Name' priority: 10)
			beRequired;
			yourself.
! !

!DLFileType class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:34'!
metaName
	^ 'Abgabedateityp'! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrExtensions
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_file_types_extensions';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_file_type_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_file_types';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_file_type_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'value';
			 instVarAt: 4 put: #string;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: nil;
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #ByteString;
		 linkedVariable: 'extensions';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFileExtensions
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_file_types_file_extensions';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_file_type_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_file_types';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_file_type_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'value';
			 instVarAt: 4 put: #string;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: nil;
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #ByteString;
		 linkedVariable: 'fileExtensions';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFiletypeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'filetype_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_file_types';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filetypeName';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTypeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'type_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_file_types';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'typeName';
		 yourself! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:47'!
canonicalName
	^ self filetypeName! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions

	^ extensions! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions: anObject

	extensions := anObject.! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:44'!
extensionsText
	^ self extensions join: ', '! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:44'!
extensionsText: aText
	"Converts the comma-separated string into an OrderedCollection and checks whether the extension starts with a dot."
	^ self extensions: (OrderedCollection newFrom: (((aText reject: [:char | char = $ .]) tokensBasedOn: $,) select: [:each | each first = $.]))! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:43'!
filetypeName

	^ filetypeName! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:43'!
filetypeName: anObject

	filetypeName := anObject.! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:45'!
initialize

	super initialize.
	self extensions: OrderedCollection new.! !

DLModel subclass: #DLGroup
	instanceVariableNames: 'groupName groupDescription lecture students'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLGroup class methodsFor: 'persistence-description' stamp: 'cr 6/6/2009 17:21'!
descriptionGroupDescription
	^ (MAStringDescription auto: 'groupDescription' label: 'Beschreibung' priority: 10)
			beRequired;
			yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'cr 6/6/2009 17:20'!
descriptionGroupName
	^ (MAStringDescription auto: 'groupName' label: 'Gruppenname' priority: 10)
			beRequired;
			yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'cr 6/6/2009 17:22'!
descriptionLecture
	^ (MASingleOptionDescription auto: 'lecture' label: 'Vorlesung' priority: 10)
			optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | ]);
			beRequired;
			yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'cr 6/6/2009 17:22'!
descriptionStudents
	^ (MAMultipleOptionDescription auto: 'students' label: 'Studenten' priority: 60)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
			yourself.
! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:34'!
metaName
	^ 'Gruppe'! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'description';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupDescription';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupName';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_groups_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_group_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_groups';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_group_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUsers
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_groups_users';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_group_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_groups';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_group_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'users_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'users_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'users';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 6/9/2009 17:48'!
canonicalName
	^ self groupName! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:58'!
collectDependentObjects
	| dependentDeadlines dependentDeliveries |
	"dependentDeadlines := (SqsSearch for: DLDeadline) select: [:aDeadline | aDeadline group = self]."
	dependentDeliveries:= (SqsSearch for: DLDelivery) select: [:aDelivery | aDelivery group = self].
	^ "dependentDeadlines," dependentDeliveries.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription

	^ groupDescription! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription: anObject

	groupDescription := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName

	^ groupName! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName: anObject

	groupName := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:32'!
initialize
	super initialize.
	self students: OrderedCollection new.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture

	^ lecture! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture: anObject

	lecture := anObject.! !

!DLGroup methodsFor: 'accessing-generated' stamp: 'cr 6/6/2009 17:23'!
students
	^ students! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:31'!
students: anObject

	students := anObject.! !

DLModel subclass: #DLLecture
	instanceVariableNames: 'lectureName lectureDescription semester teacher assistants studentAssistants students visible groupSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

DLLecture class
	instanceVariableNames: 'assistants lectureDescription lectureName teacher semester visible'!

DLLecture class
	instanceVariableNames: 'assistants lectureDescription lectureName teacher semester visible'!

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 5/27/2009 15:42'!
createLectureName: aLectureName semester: aSemester description: aDescription
	^ self new
		lectureName: aLectureName;
		semester: aSemester;
		description: aDescription;
		save;
		yourself.! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 13:52'!
descriptionAssistants
	^ (MAMultipleOptionDescription auto: 'assistants' label: 'Assistenten' priority: 40)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isAssistant ]);
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 13:52'!
descriptionGroupSize
	^ (MANumberDescription auto: 'groupSize' label: 'Gruppengre' priority: 70)
			comment: 'Maximale Gruppengre';
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 5/31/2009 16:01'!
descriptionLectureDescription
	^ (MAMemoDescription auto: 'lectureDescription' label: 'Beschreibung' priority: 20)
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 5/31/2009 16:01'!
descriptionLectureName
	^ (MAStringDescription auto: 'lectureName' label: 'Lehrveranstaltung' priority: 10)
			beRequired;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:30'!
descriptionSemester
	^ (MASingleOptionDescription auto: 'semester' label: 'Semester' priority: 50)
			optionsAndLabels: (DLSemester getKeyValueSelect: [:aSemester | aSemester year > 2008]);
			beRequired;
			reference: MAStringDescription new;
			yourself.! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 13:58'!
descriptionStudentAssistants
	^ (MAMultipleOptionDescription auto: 'studentAssistants' label: 'Studentische Assistenten' priority: 40)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isStudentAssistant ]);
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 15:58'!
descriptionStudents
	^ (MAMultipleOptionDescription auto: 'students' label: 'Studenten' priority: 60)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 18:09'!
descriptionTeacher

	^ (MASingleOptionDescription auto: 'teacher' label: 'Dozent' priority: 10)
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isTeacher]);
		yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 13:55'!
descriptionVisible
	^ (MABooleanDescription auto: 'visible' label: 'Sichtbar' priority: 70)
			default: true;
			trueString: 'Sichtbar';
			falseString:'Nicht sichtbar';
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 5/27/2009 15:47'!
getOrCreateUserName: aLectureName semester: aSemester description: aDescription

	| lecture |
	lecture := (SqsSearch for: self) detect: [:aLecture | 
		(aLecture lectureName = aLectureName) & (aLecture semester = aSemester)]
	                                 ifNone: [nil].
	lecture ifNotNil: [ ^ lecture ].
	^ self createLectureName: aLectureName semester: aSemester description: aDescription.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Vorlesung'! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAssistants
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_assistants';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'assistants_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'assistants_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'assistants';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupSize
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_size';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupSize';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureDescription';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureName';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemester
	^ SqsColumn new associatedClass: #DLSemester;
		 manuallyMaintained: false;
		 columnName: 'semester_id';
		 sqlType: #integer;
		 objectClass: #DLSemester;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semester';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudentAssistants
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_student_assistants';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'student_assistants_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'student_assistants_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'studentAssistants';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTeacher
	^ SqsColumn new associatedClass: #DLUser;
		 manuallyMaintained: false;
		 columnName: 'teacher_id';
		 sqlType: #integer;
		 objectClass: #DLUser;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'teacher';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrVisible
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'visible';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'visible';
		 yourself! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 6/6/2009 16:45'!
addStudent: aUser
	((self students indexOf: aUser) = 0) ifTrue: [
		self students add: aUser.
		self save.
	].! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants

	^ assistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants: anObject

	assistants := anObject.! !

!DLLecture methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self lectureName, ' ', self semester canonicalName! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:13'!
collectDependentObjects
	| dependentDeadlines dependentGroups |
	dependentDeadlines := (SqsSearch for: DLDeadline) select: [:aDeadline | aDeadline lecture = self].
	dependentGroups 	 := (SqsSearch for: DLGroup)    select: [:aGroup 	 | aGroup 	 lecture = self].
	^ dependentDeadlines, dependentGroups.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:08'!
descriptionCreate
 ^ self description select: [:each | #(lectureName semester lectureDescription teacher assistants studentAssistants visible) includes: each accessor selector]! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/8/2009 17:57'!
descriptionList
 ^ self description select: [:each | #(lectureName lectureDescription teacher semester) includes: each accessor selector]! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize

	^ groupSize! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize: anObject

	groupSize := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:00'!
initialize
	super initialize.
	self assistants: OrderedCollection new;
		  students: OrderedCollection new;
		  studentAssistants: OrderedCollection new.
		  ! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:23'!
lectureDescription

	^ lectureDescription! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:23'!
lectureDescription: anObject

	lectureDescription := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName

	^ lectureName! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName: anObject

	lectureName := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester

	^ semester! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester: anObject

	semester := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:00'!
studentAssistants

	^ studentAssistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:00'!
studentAssistants: anObject

	studentAssistants := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students

	^ students! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students: anObject

	students := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher

	^ teacher! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher: anObject

	teacher := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible

	^ visible! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible: anObject

	visible := anObject.! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 20:55'!
createFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	^ (self newFrom: anArray) save.
	! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:22'!
descriptionContainer
	^ super descriptionContainer
		componentRenderer: DLCssRenderer;
		yourself! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'Marik 6/9/2009 17:49'!
getKeyValueSelect: aBlock
	| objects kv |
	objects := (SqsSearch for: self) select: aBlock.
	kv := OrderedCollection new.
	objects do: [:object | kv add: (object -> object canonicalName)].
	^ kv
! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'cr 6/10/2009 12:27'!
getOrCreateFrom: anAttributeArray
	"Get an object from a given attribute array, create one if it doesn't exist yet.'"
	| objects keys values |
	keys := anAttributeArray collect: [:anAttribute | anAttribute key].
	values := anAttributeArray collect: [:anAttribute | anAttribute value].
	objects := (SqsSearch for: self) searchBy: keys withValues: values limit:2.
	
	(objects isNil) ifTrue: [ ^ (self createFrom: anAttributeArray) ].
	
	objects size > 1 ifTrue: [ ^ nil "TODO: Replace this with an exception stating that there is more than one object"].
	objects size = 1 ifTrue: [ ^ objects at: 1 ]
	ifFalse: [ ^ (self createFrom: anAttributeArray) ]! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:31'!
metaName
	^ 'DeliModel (class>>metaName berschreiben)'! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 21:09'!
newFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	| newobject |
	newobject := self new.
	anArray do: [:element | newobject perform: ((element key, ':') asSymbol) with: element value ].
	^ newobject! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:08'!
rightCreate: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:09'!
rightDelete: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:28'!
rightDetail: aUser
	^ aUser notNil.! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:09'!
rightUpdate: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 5/28/2009 10:24'!
sqsAbstractBaseClass! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 18:02'!
canonicalName
	^ nil! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/16/2009 08:53'!
collectDependencies
	"Recursively collect all objects that depend on me or are transitively connected to this object"
	| dependencies |
	dependencies := Set with: self.
	self collectDependentObjects do: [:each | dependencies addAll: each collectDependencies].
	^ dependencies! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/16/2009 01:11'!
collectDependentObjects
	"Return an iterable list that contains all objects that depend on this object, override thise method!!"
	^ {}! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminList
	^ self descriptionList! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/8/2009 17:32'!
descriptionCreate
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 15:48'!
descriptionDetail
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/3/2009 19:44'!
descriptionList
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/4/2009 22:47'!
descriptionUpdate
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserList
	^ self descriptionList! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'printing' stamp: 'sebh 6/8/2009 18:02'!
printString
	^ self canonicalName ifNil: [^ super printString]! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:26'!
rightUpdate: aUser
	^ self class rightUpdate: aUser.! !

DLModel subclass: #DLRequirement
	instanceVariableNames: 'requirementName requirementDescription filetype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLRequirement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:34'!
descriptionFiletype
	^(MASingleOptionDescription auto: 'filetype' label:'Dateityp' priority:30)
		optionsAndLabels: (DLFileType getKeyValueSelect: [:aFile | ]);
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 01:01'!
descriptionRequirementDescription
	^(MAMemoDescription auto: 'requirementDescription' label:'Beschreibung' priority:20)
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:27'!
descriptionRequirementName
	^(MAStringDescription auto: 'requirementName' label:'Title' priority:10)
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFiletype
	^ SqsColumn new associatedClass: #DLFileType;
		 manuallyMaintained: false;
		 columnName: 'filetype_id';
		 sqlType: #integer;
		 objectClass: #DLFileType;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filetype';
		 yourself! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirementDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'requirement_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'requirementDescription';
		 yourself! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirementName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'requirement_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'requirementName';
		 yourself! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 01:00'!
canonicalName
	^ self requirementName! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype

	^ filetype! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype: anObject

	filetype := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription

	^ requirementDescription! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription: anObject

	requirementDescription := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName

	^ requirementName! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName: anObject

	requirementName := anObject.! !

DLModel subclass: #DLSemester
	instanceVariableNames: 'semesterName year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLSemester class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Semester'! !

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemesterName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'semester_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semesterName';
		 yourself! !

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrYear
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'year';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'year';
		 yourself! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self semesterName, ' ', self year asString.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:14'!
collectDependentObjects
	| dependentLectures |
	dependentLectures := (SqsSearch for: DLLecture) select: [:aLecture | aLecture semester = self].
	^ dependentLectures! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName

	^ semesterName! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName: anObject

	semesterName := anObject.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year

	^ year! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year: anObject

	year := anObject.! !

DLModel subclass: #DLUser
	instanceVariableNames: 'userName realName email isAdmin isTeacher isAssistant isStudentAssistant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLUser class methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 13:30'!
createUserName: aUserName email: aEmail
	^ self new
		userName: aUserName;
		email: aEmail;
		save;
		yourself.! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/13/2009 15:45'!
descriptionEmail
	^ (MAStringDescription auto: 'email' label: 'E-Mail' priority: 30)
			addCondition: [:anEmail | anEmail matchesRegexIgnoringCase: '[A-Za-z0-9._-]+@([A-Za-z0-9._-]+\.)?hpi.uni-potsdam.de'] labelled: 'Muss eine gltige HPI-E-Mail-Adresse sein.';
			comment: 'Eine gltige HPI-E-Mail-Adresse.'
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/13/2009 15:10'!
descriptionIsAdmin
	^ (MABooleanDescription auto: 'isAdmin' label: 'Administrator' priority: 30)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:44'!
descriptionIsAssistant
	^ (MABooleanDescription auto: 'isAssistant' label: 'Assistent' priority: 40)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/9/2009 14:07'!
descriptionIsStudentAssistant
	^ (MABooleanDescription auto: 'isStudentAssistant' label: 'Studentischer Assistent' priority: 40)
			default: false;
			checkboxLabel: '';
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 6/7/2009 18:07'!
descriptionIsTeacher
	^ (MABooleanDescription auto: 'isTeacher' label: 'Dozent' priority: 40)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 13:51'!
descriptionRealName
		^ (MAStringDescription auto: 'realName' label: 'Name' priority: 20)
			beRequired;
			yourself.
		
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 12:47'!
descriptionUserName
		^ (MAStringDescription auto: 'userName' label: 'Benutzername' priority: 10)
			beRequired;
			readonly: true;
			yourself.
		
! !

!DLUser class methodsFor: 'as yet unclassified' stamp: 'sebh 6/15/2009 22:48'!
getOrCreateUserName: aUserName email: aEmail
	^ (SqsSearch for: self) detect: [:aUser | (aUser userName = aUserName)] 
								   ifNone: [ ^ self createFrom: {#userName->aUserName. #email->aEmail}].
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Benutzer'! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:23'!
sqsDescrEmail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'email';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'email';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAdmin
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_admin';
		 sqlType: #boolean;
		 objectClass: #False;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAdmin';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAssistant
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_assistant';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAssistant';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsStudentAssistant
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_student_assistant';
		 sqlType: #boolean;
		 objectClass: #False;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isStudentAssistant';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsTeacher
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_teacher';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isTeacher';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRealName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'real_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'realName';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:24'!
sqsDescrUserName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'user_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'userName';
		 yourself! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/8/2009 18:06'!
canonicalName
	^ self realName ifNil: [^ self userName]! !

!DLUser methodsFor: 'initialize-release' stamp: 'sebh 6/13/2009 19:43'!
descriptionUserUpdate
 ^ self description select: [:each | #(userName realName email) includes: each accessor selector]! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email

	^ email! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email: anObject

	email := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/17/2009 13:38'!
groupForLecture: aLecture
	^ (SqsSearch for: DLGroup) detect: [:aGroup | (aGroup students includes: self) & (aGroup lecture = aLecture)] ifNone: [nil].! !

!DLUser methodsFor: 'initialize-release' stamp: 'sebh 6/9/2009 13:59'!
initialize
	super initialize.
	self isAdmin: false.
	self isAssistant: false.
	self isStudentAssistant: false.
	self isTeacher: false.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:34'!
isAdmin
	^ isAdmin! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 5/27/2009 23:08'!
isAdmin: anObject

	isAdmin := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant

	^ isAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant: anObject

	isAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant

	^ isStudentAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant: anObject

	isStudentAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher

	^ isTeacher! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher: anObject

	isTeacher := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName

	^ realName! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName: anObject

	realName := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/13/2009 14:30'!
rightUpdate: aUser
	^ (aUser = self) | (super rightUpdate: aUser)! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName

	^ userName! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName: anObject

	userName := anObject.! !

Object subclass: #Tutorials
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tutorial'!

!Tutorials methodsFor: 'as yet unclassified' stamp: 'sebh 6/18/2009 16:21'!
DatabaseFixture
	| semester lecture deadline user userJack userJohn group session userChr userAss1 userAss2 studentSet filetype requirement |
	
	session := SqsConnectionManager getInstance sessionForClass: DLUser.
	session resetDatabase.
	
	{2009. 2010. 2011} do: [:each | 
		DLSemester new
			semesterName: 'Sommer';
			year: each;
			save.
		DLSemester new
			semesterName: 'Winter';
			year: each;
			save.
	].

	semester := (SqsSearch for: DLSemester) detect: 
	[:aSemester |( aSemester semesterName = 'Sommer') & (aSemester year = 2009)].

	user := DLUser createFrom: {
		#userName->'Sebastian.Hillig'.
		#realName->'Sebastian Hillig'. 
		#email->'Sebastian.Hillig@student.hpi.uni-potsdam.de'}.
		
	userChr := DLUser createFrom: {
		#userName->'christian.ress'. 
		#realName->'Christian Ress'. 
		#email->'christian.ress@student.hpi.uni-potsdam.de'}.
	
	userJack := DLUser createFrom: {
		#userName->'jack'. 
		#realName->'Jack Johnson'. 
		#email->'jack@hpi.uni-potsdam.de'. 
		#isAdmin->true. 
		#isTeacher->true}.
		
	userJohn := DLUser createFrom: {
		#userName->'john'. 
		#email->'john@hpi.uni-potsdam.de'. 
		#isAssistant->true}.
		
	userAss1 := DLUser createFrom: {
		#userName->'assistent1'. 
		#email->'assistent1@hpi.uni-potsdam.de'.
		#isAssistant->true}.
		
	userAss2 := DLUser createFrom: {
		#userName->'assistent2'. 
		#email->'assistent2@hpi.uni-potsdam.de'. 
		#isAssistant->true}.
	
	studentSet := OrderedCollection new add: userChr; yourself.
	
	lecture := DLLecture new
		lectureName: 'Softwaretechnik I';
		lectureDescription: 'An introduction to techniques in software development';
		semester: semester;
		students: studentSet;
		save.
	
	filetype := DLFileType createFrom: {
		#filetypeName->'Prsentation'. 		
		#extensionsText->'.pdf,.ppt,.pptx'}.
	
	requirement := DLRequirement createFrom:{
		#requirementName->'Prsentation'. 		
		#requirementDescription->'Auseinandersetzung mit Interteamrelationships in hyperaktiven Teams'. 
		#filetype->filetype}.
	
	deadline := DLDeadline createFrom: {
		#lecture-> lecture.
		#group-> nil.
		#deadlineName-> 'Abgabe'. 
		#deadlineDescription-> 'Gebt eueren Mist endlich ab'.
		#date->(Date today). 
		#time->(Time now). 		
		#requirements->(OrderedCollection with: requirement)}.

	group := DLGroup new
		groupName: 'Roundup porns';
		groupDescription: 'Roundup in awesome';
		lecture: lecture;
		students: ( {user} as: OrderedCollection );
		save.! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'sebh 6/2/2009 13:50'!
HowToResetYourDB

"session := SqsConnectionManager getInstance sessionForClass: DLUser.
session resetDatabase.
"! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:57'!
WhatToInstall
"
Von SqueakMap: Magritte 1.1.1

Announcements
MCHttpRepository
	location: 'http://source.lukas-renggli.ch/announcements'
	user: ''
	password: ''

SqsSave im Monticello updaten.

DatabaseFixture aus den Tutorials ziehen und in einem Workspace ausfhren.

Im Seaside Admin:
	Add new entry
	'deli', Application
	RootComponent DLRootTask
	SessionComponent DLSession

Benutzer aus dem fixture und mit beliebigem passwort nutzbar:
	jack - admin
	john - user
"! !

ATestCase subclass: #DLLittleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models-tests'!

!DLLittleTest methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 14:44'!
subjectApplication
	^ WADispatcher default entryPointAt: '/deli/'! !

!DLLittleTest methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 14:44'!
testStartup
	"self debug: #testStartup"
	
	self assert: browser url notEmpty.
	self assert: browser title notEmpty.
! !

SqsConfig subclass: #DeliSqsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DeliSqsConfig class methodsFor: 'as yet unclassified' stamp: 'sebh 6/15/2009 23:04'!
configuration
	| config |
	config := super configuration.
	
	config
		warnOnAlteration: false.

	^ config.! !

!DeliSqsConfig class methodsFor: 'as yet unclassified' stamp: 'cr 6/9/2009 14:41'!
connectionSpecification
	^ SqsMySQLConnectionSpecification 
		user: 'root'
		password: ''
		database: 'deli'
		port: 3306
		host: 'localhost'! !
